Package: gamma
Title: Dose Rate Estimation from in-Situ Gamma-Ray Spectrometry
        Measurements
Version: 1.1.0
Authors@R: c(
    person("Nicolas", "Frerebeau", , "nicolas.frerebeau@u-bordeaux-montaigne.fr", role = "aut",
           comment = c(ORCID = "0000-0001-5759-4944")),
    person("Brice", "Lebrun", , "brice.lebrun@u-bordeaux-montaigne.fr", role = "aut",
           comment = c(ORCID = "0000-0001-7503-8685")),
    person("Guilhem", "Paradol", , "guilhem.paradol@cea.fr", role = "aut",
           comment = c(ORCID = "0000-0002-8561-4903")),
    person("Magali", "Rizza", , "rizza@cerege.fr", role = "ctb",
           comment = c(ORCID = "0000-0003-2364-5621")),
    person("Christelle", "Lahaye", , "christelle.lahaye@u-bordeaux-montaigne.fr", role = "ctb",
           comment = c(ORCID = "0000-0003-2215-9015")),
    person("Sebastian", "Kreutzer", , "sebastian.kreutzer@uni-heidelberg.de", role = "aut",
           comment = c(ORCID = "0000-0002-0734-2199")),
    person("Archéosciences Bordeaux", , , "services-archeosciences@u-bordeaux-montaigne.fr", role = "cre"),
    person("Université Bordeaux Montaigne", role = c("cph", "fnd")),
    person("CNRS", role = "fnd"),
    person("LabEx Sciences archéologiques de Bordeaux", role = "fnd"),
    person("Idex Aix-Marseille", role = "fnd")
  )
Maintainer: Archéosciences Bordeaux <services-archeosciences@u-bordeaux-montaigne.fr>
Description: Process in-situ Gamma-Ray Spectrometry for Luminescence
    Dating. This package allows to import, inspect and correct the energy
    shifts of gamma-ray spectra. It provides methods for estimating the
    gamma dose rate by the use of a calibration curve as described in
    Mercier and Falguères (2007). The package only supports Canberra CNF
    and TKA and Kromek SPE files.
License: GPL-3
URL: https://crp2a.github.io/gamma/, https://github.com/crp2a/gamma
BugReports: https://github.com/crp2a/gamma/issues
Depends: R (>= 3.5)
Imports: ggplot2, graphics, IsoplotR, methods, rlang, rxylib, stats,
        tools, utils
Suggests: covr, knitr, rmarkdown, testthat (>= 3.0.0), vdiffr (>=
        1.0.0)
VignetteBuilder: knitr
Config/testthat/edition: 3
Encoding: UTF-8
LazyData: false
RoxygenNote: 7.3.2
Collate: 'AllClasses.R' 'AllGenerics.R' 'baseline.R'
        'baseline_linear.R' 'baseline_rubberband.R' 'baseline_snip.R'
        'coerce.R' 'data.R' 'dose_fit.R' 'dose_predict.R'
        'energy_calibrate.R' 'gamma-package.R' 'initialize.R'
        'mutators.R' 'operators.R' 'peaks_find.R' 'peaks_search.R'
        'plot.R' 'read.R' 'show.R' 'signal_integrate.R'
        'signal_slice.R' 'signal_split.R' 'signal_stabilize.R'
        'smooth.R' 'smooth_rectangular.R' 'smooth_savitzky.R'
        'smooth_triangular.R' 'subset.R' 'summarize.R' 'utilities.R'
        'validate.R' 'zzz.R'
NeedsCompilation: no
Packaged: 2024-09-23 19:26:18 UTC; nicolas
Author: Nicolas Frerebeau [aut] (<https://orcid.org/0000-0001-5759-4944>),
  Brice Lebrun [aut] (<https://orcid.org/0000-0001-7503-8685>),
  Guilhem Paradol [aut] (<https://orcid.org/0000-0002-8561-4903>),
  Magali Rizza [ctb] (<https://orcid.org/0000-0003-2364-5621>),
  Christelle Lahaye [ctb] (<https://orcid.org/0000-0003-2215-9015>),
  Sebastian Kreutzer [aut] (<https://orcid.org/0000-0002-0734-2199>),
  Archéosciences Bordeaux [cre],
  Université Bordeaux Montaigne [cph, fnd],
  CNRS [fnd],
  LabEx Sciences archéologiques de Bordeaux [fnd],
  Idex Aix-Marseille [fnd]
Repository: CRAN
Date/Publication: 2024-09-23 22:00:12 UTC
Built: R 4.6.0; ; 2026-04-28 03:46:36 UTC; unix

Package: gamma
Title: Dose Rate Estimation from in-Situ Gamma-Ray Spectrometry
        Measurements
Version: 1.1.0
Authors@R: c(
    person("Nicolas", "Frerebeau", , "nicolas.frerebeau@u-bordeaux-montaigne.fr", role = "aut",
           comment = c(ORCID = "0000-0001-5759-4944")),
    person("Brice", "Lebrun", , "brice.lebrun@u-bordeaux-montaigne.fr", role = "aut",
           comment = c(ORCID = "0000-0001-7503-8685")),
    person("Guilhem", "Paradol", , "guilhem.paradol@cea.fr", role = "aut",
           comment = c(ORCID = "0000-0002-8561-4903")),
    person("Magali", "Rizza", , "rizza@cerege.fr", role = "ctb",
           comment = c(ORCID = "0000-0003-2364-5621")),
    person("Christelle", "Lahaye", , "christelle.lahaye@u-bordeaux-montaigne.fr", role = "ctb",
           comment = c(ORCID = "0000-0003-2215-9015")),
    person("Sebastian", "Kreutzer", , "sebastian.kreutzer@uni-heidelberg.de", role = "aut",
           comment = c(ORCID = "0000-0002-0734-2199")),
    person("Archéosciences Bordeaux", , , "services-archeosciences@u-bordeaux-montaigne.fr", role = "cre"),
    person("Université Bordeaux Montaigne", role = c("cph", "fnd")),
    person("CNRS", role = "fnd"),
    person("LabEx Sciences archéologiques de Bordeaux", role = "fnd"),
    person("Idex Aix-Marseille", role = "fnd")
  )
Maintainer: Archéosciences Bordeaux <services-archeosciences@u-bordeaux-montaigne.fr>
Description: Process in-situ Gamma-Ray Spectrometry for Luminescence
    Dating. This package allows to import, inspect and correct the energy
    shifts of gamma-ray spectra. It provides methods for estimating the
    gamma dose rate by the use of a calibration curve as described in
    Mercier and Falguères (2007). The package only supports Canberra CNF
    and TKA and Kromek SPE files.
License: GPL-3
URL: https://crp2a.github.io/gamma/, https://github.com/crp2a/gamma
BugReports: https://github.com/crp2a/gamma/issues
Depends: R (>= 3.5)
Imports: ggplot2, graphics, IsoplotR, methods, rlang, rxylib, stats,
        tools, utils
Suggests: covr, knitr, rmarkdown, testthat (>= 3.0.0), vdiffr (>=
        1.0.0)
VignetteBuilder: knitr
Config/testthat/edition: 3
Encoding: UTF-8
LazyData: false
RoxygenNote: 7.3.2
Collate: 'AllClasses.R' 'AllGenerics.R' 'baseline.R'
        'baseline_linear.R' 'baseline_rubberband.R' 'baseline_snip.R'
        'coerce.R' 'data.R' 'dose_fit.R' 'dose_predict.R'
        'energy_calibrate.R' 'gamma-package.R' 'initialize.R'
        'mutators.R' 'operators.R' 'peaks_find.R' 'peaks_search.R'
        'plot.R' 'read.R' 'show.R' 'signal_integrate.R'
        'signal_slice.R' 'signal_split.R' 'signal_stabilize.R'
        'smooth.R' 'smooth_rectangular.R' 'smooth_savitzky.R'
        'smooth_triangular.R' 'subset.R' 'summarize.R' 'utilities.R'
        'validate.R' 'zzz.R'
NeedsCompilation: no
Packaged: 2024-09-23 19:26:18 UTC; nicolas
Author: Nicolas Frerebeau [aut] (<https://orcid.org/0000-0001-5759-4944>),
  Brice Lebrun [aut] (<https://orcid.org/0000-0001-7503-8685>),
  Guilhem Paradol [aut] (<https://orcid.org/0000-0002-8561-4903>),
  Magali Rizza [ctb] (<https://orcid.org/0000-0003-2364-5621>),
  Christelle Lahaye [ctb] (<https://orcid.org/0000-0003-2215-9015>),
  Sebastian Kreutzer [aut] (<https://orcid.org/0000-0002-0734-2199>),
  Archéosciences Bordeaux [cre],
  Université Bordeaux Montaigne [cph, fnd],
  CNRS [fnd],
  LabEx Sciences archéologiques de Bordeaux [fnd],
  Idex Aix-Marseille [fnd]
Repository: CRAN
Date/Publication: 2024-09-23 22:00:12 UTC
Built: R 4.6.0; ; 2026-04-26 07:34:26 UTC; unix

# Generated by roxygen2: do not edit by hand

S3method(as.data.frame,GammaSpectrum)
S3method(as.data.frame,PeakPosition)
S3method(as.list,PeakPosition)
S3method(as.matrix,GammaSpectrum)
S3method(as.matrix,PeakPosition)
exportMethods("[")
exportMethods("[[")
exportMethods("set_energy<-")
exportMethods("set_energy_calibration<-")
exportMethods("set_method<-")
exportMethods("set_names<-")
exportMethods(Arith)
exportMethods(Compare)
exportMethods(Logic)
exportMethods(Math)
exportMethods(Math2)
exportMethods(Summary)
exportMethods(baseline_linear)
exportMethods(baseline_rubberband)
exportMethods(baseline_snip)
exportMethods(dose_fit)
exportMethods(dose_predict)
exportMethods(energy_calibrate)
exportMethods(get_channels)
exportMethods(get_counts)
exportMethods(get_energy)
exportMethods(get_energy_calibration)
exportMethods(get_hash)
exportMethods(get_livetime)
exportMethods(get_method)
exportMethods(get_names)
exportMethods(get_rates)
exportMethods(get_realtime)
exportMethods(get_residuals)
exportMethods(has_calibration)
exportMethods(has_energy)
exportMethods(length)
exportMethods(peaks_find)
exportMethods(peaks_search)
exportMethods(plot)
exportMethods(range_channels)
exportMethods(range_energy)
exportMethods(read)
exportMethods(signal_baseline)
exportMethods(signal_correct)
exportMethods(signal_integrate)
exportMethods(signal_slice)
exportMethods(signal_smooth)
exportMethods(signal_split)
exportMethods(signal_stabilize)
exportMethods(smooth_rectangular)
exportMethods(smooth_savitzky)
exportMethods(smooth_triangular)
exportMethods(summarise)
importFrom(IsoplotR,york)
importFrom(ggplot2,aes)
importFrom(ggplot2,coord_cartesian)
importFrom(ggplot2,element_text)
importFrom(ggplot2,facet_wrap)
importFrom(ggplot2,geom_errorbar)
importFrom(ggplot2,geom_errorbarh)
importFrom(ggplot2,geom_path)
importFrom(ggplot2,geom_point)
importFrom(ggplot2,geom_pointrange)
importFrom(ggplot2,geom_segment)
importFrom(ggplot2,geom_vline)
importFrom(ggplot2,ggplot)
importFrom(ggplot2,ggsave)
importFrom(ggplot2,labs)
importFrom(ggplot2,scale_x_continuous)
importFrom(ggplot2,sec_axis)
importFrom(ggplot2,theme)
importFrom(ggplot2,theme_bw)
importFrom(ggplot2,vars)
importFrom(ggplot2,waiver)
importFrom(graphics,plot)
importFrom(methods,"as<-")
importFrom(methods,"slot<-")
importFrom(methods,Arith)
importFrom(methods,Compare)
importFrom(methods,Logic)
importFrom(methods,Math)
importFrom(methods,Math2)
importFrom(methods,Summary)
importFrom(methods,as)
importFrom(methods,callGeneric)
importFrom(methods,new)
importFrom(methods,setClass)
importFrom(methods,setClassUnion)
importFrom(methods,setGeneric)
importFrom(methods,setMethod)
importFrom(methods,slot)
importFrom(rlang,.data)
importFrom(tools,file_ext)
importFrom(tools,file_path_sans_ext)
importFrom(tools,list_files_with_exts)
importFrom(tools,md5sum)

#!/bin/more

Example Programs for use with Gamma under Photon
================================================

The example programs are intended to help you become confident in
developing a few test programs of your own, using the evaluation
software we have provided.  Although the example programs are often
only a few lines of actual code, they implement functionality that is
considerably more complex to express using other less advanced
programming languages.

We hope you find enough information in these example for you to start
developing your own applications.

You have received the following example programs:

Example 1. Gamma language overview
Example 2. Object-oriented features
Example 3. Lists
Example 4. Error handling
Example 5. Dynamic scoping
Example 6. Photon coding in Gamma
Example 7. Photon coding using PhAB
Example 8. Callbacks
Example 9. Timers
Example 10. Dynamic arrays
Example 11. Active values
Example 12. Inter-process communication (IPC)


How to run the examples
-----------------------

All examples cited in this document are automatically installed when
you install the evaluation version of Gamma from the floppy disk.  The
examples can be found under the directory:

	/usr/cogent/examples

Each example is named example01, example02, etc. Each example contains
extensive documentation to explain how each example program works.  To
view the source code for each example, just edit the appropriate
example file.  The /usr/cogent/examples directory also contains a
number of ".wgtw" window files created by the Photon Application
Builder (PhAB).

To run any of the examples, move to the /usr/cogent/examples directory
and type the name of the example (e.g. example01, example02, etc.).

To stop any of the examples, click on the menu button in the upper
left-hand corner of the window and select Close. Alternately,
highlight the example window and use the key-chord Ctrl+F4.


Example 1 - Gamma language overview
-----------------------------------

The syntax of Gamma is very similar to C.  Programmers familiar with C
will find they can immediately start programming in Gamma.  This first
example program demonstrates the basic similarities between Gamma and
the C language, and some important differences that highlight the
power of Gamma.

Example 2 - Object-oriented features
------------------------------------

Gamma implements Object Oriented Programming features which provide a
single-inheritance class mechanism with instance variables and
methods.  Since Gamma is an interpreter, the object definitions are
truly dynamic, allowing for run-time extensibility.  This example
provides the simplest of starting points to this key software
methodology.

Example 3 - Lists
-----------------

This example demonstrates some of the basics of list manipulation.
Since Gamma uses the SCADALisp engine, it inherits the rich set of
list manipulation functions for which LISP is known.

Example 4 - Error handling
--------------------------

This example demonstrates the error handling mechanisms available in
Gamma.  There are two basic means of trapping and handling errors.

1) Execute a protected block of code, and specify an error handler
which is only executed if an error occurs within the protected code.
If an error occurs, the error handling code is executed, and the error
condition is cleared.  This is the TRY/CATCH mechanism.
 
2) Execute a protected block of code, and specify a second block of
code which must be executed even if an error occurs in the first
block.  Normally when an error occurs, the execution stack is unwound
to the nearest error handler, aborting any intervening execution
immediately.  If a block of code must be run, even when an error
occurs, we want to unwind protect that code.  After the error is dealt
with, it is passed on up the stack rather than being cleared.  This is
the PROTECT/UNWIND mechanism.

Example 5 - Dynamic scoping
---------------------------

This example uses the error handling mechanisms from example04 to
demonstrate dynamic scoping.  Most compiled languages use lexical
scoping, which means that a variable is defined only where it is
visibly declared, either as an external global, file global, or local
variable.  Gamma uses dynamic scoping, meaning that a variable is
defined in any function which defines it, and in any function which
the defining function subsequently calls.  This powerful mechanism
allows the programmer to override global variables by defining them in
a higher scope, and then calling a function which believes itself to
be using a global variable.

One useful side-effect of dynamic scoping is that functions and
variables do not have to be declared before they are used in other
functions.  The function or variable only has to be declared when the
other function is actually run.

Example 6 - Photon coding in Gamma
----------------------------------

This example demonstrates how to create a Photon application in Gamma.
Since the Photon widget set is mapped as OOP classes in Gamma, any
Photon widget can be created using the new function and then
manipulated by simply modifying its instance variables.

Example 7 - Photon coding using PhAB
------------------------------------

This example shows the minimal program required to create a Photon
application using Gamma and a window created in PhAB.  PhAB creates a
file with a .wgtw extension which Gamma can read and display.  Widget
names in PhAB are mapped to Gamma global variables for easy access.
Creating windows using PhAB gives you all of the advantages of using a
graphical editor to quickly create your user interface and Gamma
allows you to create the application code in a fraction of the time
required for the same C functionality.

Example 8 - Callbacks
---------------------

After a window is created in code or loaded from a PhAB definition
file, one of the most common things to do is to attach callbacks to
the window items.  A callback is a block of code which will be
executed whenever a particular Photon event occurs. Gamma greatly
enhances the Photon callback mechanism to allow any Gamma expression
to be attached to a callback.  This example demonstrates some simple
Photon callbacks.

Example 9 - Timers
------------------

Timers are one of the easiest and most powerful features of Gamma.
There are three kinds of timers supported by Gamma:

	 every	- interval timer
	 after	- one-shot timer
	 at	- calendar (time-of-day) timer

This example demonstrates several uses of timers.

Example 10 - Dynamic arrays
---------------------------

Another powerful feature of Gamma is dynamic arrays. To make an array
in Gamma the developer can use either the array() or make-array()
functions.  The array() function creates a pre-built array while the
make-array() function creates an empty array of a given size.  If the
programmer attempts to write to an element beyond the end of the
array, the array will expand to accept the new element.  This
mechanism allows the programmer to approximate the size of the array,
and then increase its size as necessary simply by using it.

Example 11 - Active values
--------------------------

This example demonstrates the use of active values.  An active value
is a symbol which also carries code to be executed whenever its value
changes.  This is useful for adding side-effects to program variables.
For example, it might be very useful to add a function which will
update a Photon widget whenever a variable changes.  Active values
make it possible to implement algorithms such as forward-chaining
expert systems very easily.  An active value is established by calling
the add-set-function function.

Example 12 - Inter-process communication (IPC)
----------------------------------------------

This is a simple example of communicating with a Gamma application
through program control.  There is a text file called example12.doc in
the /usr/cogent/examples directory, which walks you through an
interactive session allowing you to modify a program as it runs.

The example12 program itself, will perform the same steps as the
interactive sample, without the interactive component.

To run, start example08 in the background by typing:

	example08 &

and then run this program using:

	example12

This program will exit when it completes. 

<!-- README.md is generated from README.Rmd. Please edit that file -->

# gamma <img width=120px src="man/figures/logo.png" align="right" />

<!-- badges: start -->

[![R-CMD-check](https://github.com/crp2a/gamma/actions/workflows/R-CMD-check.yaml/badge.svg)](https://github.com/crp2a/gamma/actions/workflows/R-CMD-check.yaml)
[![codecov](https://codecov.io/gh/crp2a/gamma/branch/master/graph/badge.svg)](https://app.codecov.io/gh/crp2a/gamma)

<a href="https://crp2a.r-universe.dev" class="pkgdown-devel"><img
src="https://crp2a.r-universe.dev/badges/gamma" alt="r-universe" /></a>
<a href="https://cran.r-project.org/package=gamma"
class="pkgdown-release"><img
src="https://www.r-pkg.org/badges/version/gamma"
alt="CRAN Version" /></a>
<a href="https://cran.r-project.org/web/checks/check_results_gamma.html"
class="pkgdown-release"><img
src="https://badges.cranchecks.info/worst/gamma.svg"
alt="CRAN checks" /></a>
<a href="https://cran.r-project.org/package=gamma"
class="pkgdown-release"><img
src="https://cranlogs.r-pkg.org/badges/gamma"
alt="CRAN Downloads" /></a>

[![Project Status: Active – The project has reached a stable, usable
state and is being actively
developed.](https://www.repostatus.org/badges/latest/active.svg)](https://www.repostatus.org/#active)

[![DOI](https://zenodo.org/badge/DOI/10.5281/zenodo.2652393.svg)](https://doi.org/10.5281/zenodo.2652393)
[![CRAN
DOI](https://img.shields.io/badge/DOI-10.32614/CRAN.package.gamma-1f57b6?style=flat&link=https://doi.org/10.32614/CRAN.package.gamma)](https://doi.org/10.32614/CRAN.package.gamma)

[![SWH](https://archive.softwareheritage.org/badge/swh:1:dir:459ecf47c4c0bb768732bd56c5c245ddab0d33f9/)](https://archive.softwareheritage.org/swh:1:dir:459ecf47c4c0bb768732bd56c5c245ddab0d33f9;origin=https://github.com/crp2a/gamma;visit=swh:1:snp:10e6be6e5cbe735b58c45abbcbabf20b93019e9c;anchor=swh:1:rev:1b3baf8821267ed656d780ae154d347769141d0c/)
<!-- badges: end -->

## Overview

**gamma** is intended to process in-situ gamma-ray spectrometry
measurements for luminescence dating. This package allows to import,
inspect and (automatically) correct the energy scale of the spectrum. It
provides methods for estimating the gamma dose rate by the use of a
calibration curve. This package only supports Canberra CNF and TKA and
Kromek SPE files.

The [**gammaShiny**](https://github.com/crp2a/gammaShiny) package
provides an enhanced graphical user interface for the main applications
of **gamma**.

    To cite gamma in publications use:

      Lebrun B, Frerebeau N, Paradol G, Guérin G, Mercier N, Tribolo C,
      Lahaye C, Rizza M (2020). "gamma: An R Package for Dose Rate
      Estimation from In-Situ Gamma-Ray Spectrometry Measurements."
      _Ancient TL_, *38*(2), 1-5.

      Frerebeau N, Lebrun B, Paradol G, Kreutzer S (2024). _gamma: Dose
      Rate Estimation from in-Situ Gamma-Ray Spectrometry_. Université
      Bordeaux Montaigne, Pessac, France. doi:10.5281/zenodo.2652393
      <https://doi.org/10.5281/zenodo.2652393>, R package version 1.1.0.

## Installation

You can install the released version of **gamma** from
[CRAN](https://CRAN.R-project.org) with:

``` r
install.packages("gamma")
```

And the development version from [GitHub](https://github.com/) with:

``` r
# install.packages("remotes")
remotes::install_github("crp2a/gamma")
```

## Usage

``` r
## A minimal example
library(gamma)

## Find the full path to the spectrum file
spc_file <- system.file("extdata/LaBr.CNF", package = "gamma")
## Import the spectrum
spectrum <- read(spc_file)

## Set the expected channel/energy peaks for the energy scale calibration
## Spectrum pre-processing and peak detection
peaks <- spectrum |>
  signal_slice() |>
  signal_stabilize(f = sqrt) |>
  signal_smooth(method = "savitzky", m = 21) |>
  signal_correct(method = "SNIP", n = 100) |>
  peaks_find()

## Set the energy values (in keV)
set_energy(peaks) <- c(238, NA, NA, NA, 1461, NA, NA, 2615)

## Calibrate the energy scale
calib <- energy_calibrate(spectrum, peaks)

## Inspect peaks
plot(calib, peaks)
```

<img src="man/figures/README-usage-1.png" style="display: block; margin: auto;" />

``` r
## Estimate the gamma dose rate of a set of spectra
## You may want to give extra attention to the energy calibration step
spc_file <- system.file("extdata/BDX_LaBr_1/test", package = "gamma")
spectra <- read(spc_file)

## Load the calibration curve for the dose rate estimation
## As this curve is instrument specific, you will have to build your own
data("BDX_LaBr_1", package = "gamma")
plot(BDX_LaBr_1)
```

<img src="man/figures/README-calib-1.png" style="display: block; margin: auto;" />

``` r
## Estimate the gamma dose rate
(doses <- dose_predict(BDX_LaBr_1, spectra))
```

| name           | signal_Ni | signal_err_Ni |   dose_Ni | dose_err_Ni | signal_NiEi | signal_err_NiEi | dose_NiEi | dose_err_NiEi | dose_final | dose_err_final |
|:---------------|----------:|--------------:|----------:|------------:|------------:|----------------:|----------:|--------------:|-----------:|---------------:|
| 20110523204008 |  8.604666 |     0.2691316 |  252.2866 |   10.372500 |    7626.493 |        8.747617 |  220.6747 |      5.495079 |   236.4806 |      11.366900 |
| 20110523210008 |  8.775092 |     0.2166075 |  257.3316 |    9.354274 |    7577.302 |        7.021326 |  219.1303 |      5.454610 |   238.2309 |      10.495729 |
| 20110527205316 |  8.445976 |     0.1546491 |  247.5890 |    8.012680 |    7064.449 |        5.009961 |  203.0288 |      5.052359 |   225.3089 |       9.198048 |
| 20130809172451 | 30.218479 |     0.2549754 |  892.1003 |   24.967288 |   27667.473 |        8.089989 |  849.8817 |     21.142124 |   870.9910 |      32.614162 |
| 20130813181639 | 36.062314 |     0.2853286 | 1065.0899 |   29.644785 |   33243.050 |        9.028097 | 1024.9325 |     25.496544 |  1045.0112 |      39.010062 |
| 20160717175757 | 19.190250 |     0.3635398 |  565.6418 |   18.510895 |   16419.873 |       11.495584 |  496.7518 |     12.361511 |   531.1968 |      21.838611 |
| 20160717181052 | 16.303659 |     0.2837191 |  480.1928 |   15.297869 |   14033.831 |        9.033011 |  421.8396 |     10.496701 |   451.0162 |      18.231817 |
| 20160717182601 | 16.896441 |     0.2557337 |  497.7403 |   15.269850 |   14493.495 |        8.131459 |  436.2712 |     10.854933 |   467.0058 |      18.446627 |

## Contributing

Please note that the **gamma** project is released with a [Contributor
Code of
Conduct](https://github.com/crp2a/gamma/blob/master/.github/CODE_OF_CONDUCT.md).
By contributing to this project, you agree to abide by its terms.

## Acknowledgements

This work received a state financial support managed by the Agence
Nationale de la Recherche (France) through the program *Investissements
d’avenir* (ref. 10-LABX-0052 and 11-IDEX-0001).

# Import CNF files
spc_file <- system.file("extdata/LaBr.CNF", package = "gamma")
spc <- read(spc_file)
spc <- signal_slice(spc, -c(1:35))

# Plot raw spectrum
spc_clean <- signal_correct(spc)
plot(spc_clean)

# Rectangular smooth
spc_unweighted <- smooth_rectangular(spc, m = 3)
spc_unweighted_clean <- signal_correct(spc_unweighted)
plot(spc_unweighted_clean)

# Triangular smooth
spc_weighted <- smooth_triangular(spc, m = 5)
spc_weighted_clean <- signal_correct(spc_weighted)
plot(spc_weighted_clean)

# Savitzky–Golay
spc_savitzky <- smooth_savitzky(spc, m = 21, p = 2)
spc_savitzky_clean <- signal_correct(spc_savitzky)
plot(spc_savitzky_clean)

## Import a Canberra CNF file
cnf_file <- system.file("extdata/LaBr.CNF", package = "gamma")
(cnf_spc <- read(cnf_file))

## Import a TKA file
tka_file <- system.file("extdata/LaBr.TKA", package = "gamma")
(tka_spc <- read(tka_file))

## Import all files in a given directory
spc_dir <- system.file("extdata/BDX_LaBr_1/calibration", package = "gamma")
(spc <- read(spc_dir))

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  message = FALSE,
  fig.width = 7,
  fig.height = 3.5,
  comment = "#>"
)

## ----packages-----------------------------------------------------------------
library(gamma)

## ----import-------------------------------------------------------------------
# Import CNF files for calibration
spc_dir <- system.file("extdata/AIX_NaI_1/calibration", package = "gamma")
spc <- read(spc_dir)
spc

# Import a CNF file of background measurement
bkg_dir <- system.file("extdata/AIX_NaI_1/background", package = "gamma")
bkg <- read(bkg_dir)
bkg

## ----signal-------------------------------------------------------------------
# Spectrum pre-processing
# Remove baseline for peak detection
bsl <- spc |>
  signal_slice(-1:-40) |>
  signal_stabilize(f = sqrt) |>
  signal_smooth(method = "savitzky", m = 21) |>
  signal_correct()

## ----calibrate-BRIQUE---------------------------------------------------------
# Peak detection
pks <- peaks_find(bsl[["BRIQUE"]])
# Set energy values
set_energy(pks) <- c(238, NA, NA, NA, 1461, NA, NA, 2615)
# Adjust the energy scale
BRIQUE <- energy_calibrate(spc[["BRIQUE"]], pks)

## ----plot-BRIQUE, echo=FALSE--------------------------------------------------
plot(BRIQUE, pks) +
  ggplot2::theme_bw()

## ----calibrate-C341-----------------------------------------------------------
# Spectrum pre-processing and peak detection
pks <- peaks_find(bsl[["C341"]])
# Set energy values
set_energy(pks) <- c(238, NA, NA, NA, 1461, NA, 2615)
# Adjust the energy scale
C341 <- energy_calibrate(spc[["C341"]], pks)

## ----plot-C341, echo=FALSE----------------------------------------------------
plot(C341, pks) +
  ggplot2::theme_bw()

## ----calibrate-C347-----------------------------------------------------------
# Spectrum pre-processing and peak detection
pks <- peaks_find(bsl[["C347"]], span = 10)
# Set energy values
set_energy(pks) <- c(238, NA, NA, NA, NA, 1461, NA, 2615)
# Adjust the energy scale
C347 <- energy_calibrate(spc[["C347"]], pks)

## ----plot-C347, echo=FALSE----------------------------------------------------
plot(C347, pks) +
  ggplot2::theme_bw()

## ----calibrate-GOU------------------------------------------------------------
# Spectrum pre-processing and peak detection
pks <- peaks_find(bsl[["GOU"]])
# Set energy values
set_energy(pks) <- c(238, NA, NA, NA, 1461, NA, NA, 2615)
# Adjust the energy scale
GOU <- energy_calibrate(spc[["GOU"]], pks)

## ----plot-GOU, echo=FALSE-----------------------------------------------------
plot(GOU, pks) +
  ggplot2::theme_bw()

## ----calibrate-PEP------------------------------------------------------------
# Spectrum pre-processing and peak detection
pks <- peaks_find(bsl[["PEP"]])
# Set energy values
set_energy(pks) <- c(238, NA, NA, NA, 1461, NA, NA, 2615)
# Adjust the energy scale
PEP <- energy_calibrate(spc[["PEP"]], pks)

## ----plot-PEP, echo=FALSE-----------------------------------------------------
plot(PEP, pks) +
  ggplot2::theme_bw()

## ----calibrate-bkg------------------------------------------------------------
# Pb212, K40, Tl208
lines <- data.frame(
  channel = c(86, 496, 870),
  energy = c(238, 1461, 2615)
) 
bkg_scaled <- energy_calibrate(bkg, lines = lines)

## ----plot-bkg, echo=FALSE-----------------------------------------------------
plot(bkg_scaled, xaxis = "energy", yaxis = "rate") +
  ggplot2::geom_vline(xintercept = c(238, 1461, 2615), linetype = 3) +
  ggplot2::theme_bw()

## ----calibrate-spc------------------------------------------------------------
spc_scaled <- list(BRIQUE, C341, C347, GOU, PEP)
spc_scaled <- methods::as(spc_scaled, "GammaSpectra")
spc_scaled

## ----integrate-Ni-------------------------------------------------------------
# Integration range (in keV)
Ni_range <- c(200, 2800)

# Integrate background spectrum
Ni_bkg <- signal_integrate(
  object = bkg_scaled, 
  range = Ni_range, 
  energy = FALSE)

# Integrate reference spectra
Ni_spc <- signal_integrate(
  object = spc_scaled, 
  range = Ni_range, 
  background = Ni_bkg, 
  energy = FALSE, 
  simplify = TRUE)

## ----integrate-NiEi-----------------------------------------------------------
# Integration range (in keV)
NiEi_range <- c(200, 2800)

# Integrate background spectrum
NiEi_bkg <- signal_integrate(
  object = bkg_scaled, 
  range = NiEi_range, 
  energy = TRUE)

# Integrate reference spectra
NiEi_signal <- signal_integrate(
  object = spc_scaled, 
  range = NiEi_range, 
  background = NiEi_bkg, 
  energy = TRUE,
  simplify = TRUE)

## -----------------------------------------------------------------------------
# Get reference dose rates
data("clermont")
doses <- clermont[, c("gamma_dose", "gamma_error")]

## ----echo = FALSE-------------------------------------------------------------
knitr::kable(clermont)

## -----------------------------------------------------------------------------
# Metadata
info <- list(
  laboratory = "CEREGE",
  instrument = "InSpector 1000",
  detector = "NaI",
  authors = "CEREGE Luminescence Team"
)

## -----------------------------------------------------------------------------
# Build the calibration curve
AIX_NaI <- dose_fit(
  object = spc_scaled, 
  background = bkg_scaled, 
  doses = doses,
  range_Ni = Ni_range, 
  range_NiEi = NiEi_range,
  details = info
)
AIX_NaI 

## -----------------------------------------------------------------------------
# show summary
summarise(AIX_NaI)

## ----calibration, fig.width=3.5, fig.show='hold'------------------------------
# plot calibration curves
plot(AIX_NaI, energy = FALSE) +
  ggplot2::theme_bw()
plot(AIX_NaI, energy = TRUE) +
  ggplot2::theme_bw()

## ----eval=FALSE---------------------------------------------------------------
#  save(AIX_NaI, file = "<you_path>/<date>_NaI_DoseRate_Calibration.rda")

## ----save, eval=FALSE, echo=FALSE---------------------------------------------
#  # DANGER ZONE
#  # AIX_NaI_1 <- AIX_NaI
#  # usethis::use_data(AIX_NaI_1, internal = FALSE, overwrite = FALSE)

## ----check-Ni, echo=FALSE, fig.width=3.5, fig.show='hold'---------------------
Ni_residuals  <- get_residuals(AIX_NaI[["Ni"]])

# Residuals vs fitted values
ggplot2::ggplot(Ni_residuals, ggplot2::aes(x = fitted, y = residuals)) +
  ggplot2::geom_hline(yintercept = 0, linetype = 3) +
  ggplot2::geom_segment(ggplot2::aes(x = fitted, xend = fitted,
                                     y = 0, yend = residuals)) + 
  ggplot2::geom_point() +
  ggplot2::theme_bw() +
  ggplot2::labs(title = "Residuals vs fitted values",
                x = "Fitted values", y = "Residuals")

# Std. residuals vs fitted values
ggplot2::ggplot(Ni_residuals, ggplot2::aes(x = fitted, y = standardized)) +
  ggplot2::geom_hline(yintercept = 0, linetype = 3) +
  ggplot2::geom_hline(yintercept = c(-2, 2), linetype = 2) +
  ggplot2::geom_segment(ggplot2::aes(x = fitted, xend = fitted,
                                     y = 0, yend = standardized)) + 
  ggplot2::geom_point() +
  ggplot2::theme_bw() +
  ggplot2::labs(title = "Std. residuals vs fitted values",
                x = "Fitted values", y = "Standardized residuals")

# Normal QQ plot of standardized residuals
ggplot2::ggplot(Ni_residuals, ggplot2::aes(sample = standardized)) +
  ggplot2::geom_abline(slope = 1, intercept = 0) +
  ggplot2::geom_qq_line(colour = "red") +
  ggplot2::geom_qq() +
  ggplot2::theme_bw() +
  ggplot2::labs(title = "Normal QQ plot",
                x = "Theoretical quantiles",
                y = "Standardize residuals")

# Cook's distance
# ggplot2::ggplot(Ni_residuals, ggplot2::aes(x = name, y = cook)) +
#   ggplot2::geom_hline(yintercept = 0, linetype = 3) +
#   ggplot2::geom_hline(yintercept = 1, linetype = 2) +
#   ggplot2::geom_segment(ggplot2::aes(x = name, xend = name,
#                                      y = 0, yend = cook)) +
#   ggplot2::geom_point() +
#   ggplot2::theme_bw() +
#   ggplot2::labs(title = "Cook's distance",
#                 x = "Observation", y = "D")

## ----check-NiEi, echo=FALSE, fig.width=3.5, fig.show='hold'-------------------
NiEi_residuals  <- get_residuals(AIX_NaI[["NiEi"]])

# Residuals vs fitted values
ggplot2::ggplot(NiEi_residuals, ggplot2::aes(x = fitted, y = residuals)) +
  ggplot2::geom_hline(yintercept = 0, linetype = 3) +
  ggplot2::geom_segment(ggplot2::aes(x = fitted, xend = fitted,
                                     y = 0, yend = residuals)) + 
  ggplot2::geom_point() +
  ggplot2::theme_bw() +
  ggplot2::labs(title = "Residuals vs fitted values",
                x = "Fitted values", y = "Residuals")

# Std. residuals vs fitted values
ggplot2::ggplot(NiEi_residuals, ggplot2::aes(x = fitted, y = standardized)) +
  ggplot2::geom_hline(yintercept = 0, linetype = 3) +
  ggplot2::geom_hline(yintercept = c(-2, 2), linetype = 2) +
  ggplot2::geom_segment(ggplot2::aes(x = fitted, xend = fitted,
                                     y = 0, yend = standardized)) + 
  ggplot2::geom_point() +
  ggplot2::theme_bw() +
  ggplot2::labs(title = "Std. residuals vs fitted values",
                x = "Fitted values", y = "Standardized residuals")

# Normal QQ plot of standardized residuals
ggplot2::ggplot(NiEi_residuals, ggplot2::aes(sample = standardized)) +
  ggplot2::geom_abline(slope = 1, intercept = 0) +
  ggplot2::geom_qq_line(colour = "red") +
  ggplot2::geom_qq() +
  ggplot2::theme_bw() +
  ggplot2::labs(title = "Normal QQ plot",
                x = "Theoretical quantiles",
                y = "Standardize residuals")

# Cook's distance
# ggplot2::ggplot(NiEi_residuals, ggplot2::aes(x = name, y = cook)) +
#   ggplot2::geom_hline(yintercept = 0, linetype = 3) +
#   ggplot2::geom_hline(yintercept = 1, linetype = 2) +
#   ggplot2::geom_segment(ggplot2::aes(x = name, xend = name,
#                                      y = 0, yend = cook)) +
#   ggplot2::geom_point() +
#   ggplot2::theme_bw() +
#   ggplot2::labs(title = "Cook's distance",
#                 x = "Observation", y = "D")

## -----------------------------------------------------------------------------
# Import CNF files for dose rate prediction
test_dir <- system.file("extdata/AIX_NaI_1/test", package = "gamma")
test <- read(test_dir)

## ----predict------------------------------------------------------------------
# Inspect spectra
plot(test, yaxis = "rate") +
  ggplot2::theme_bw()

## -----------------------------------------------------------------------------
# Pb212, K40, Tl208
pks <- data.frame(
  channel = c(86, 490, 870),
  energy = c(238, 1461, 2615)
) |> as("PeakPosition")

## energy calibrate
test <- energy_calibrate(test, pks)

## check the calibration for one curve
plot(test[[1]], pks) +
  ggplot2::theme_bw()

## show all energy calibrated spectra 
# Inspect spectra
plot(test, xaxis = "energy", yaxis = "rate") +
  ggplot2::theme_bw()

## -----------------------------------------------------------------------------
rates <- dose_predict(AIX_NaI, test, sigma = 1.96)
rates

## ----session-info, echo=FALSE-------------------------------------------------
sessionInfo()

## Import a Canberra CNF file
cnf_file <- system.file("extdata/LaBr.CNF", package = "gamma")
spc <- read(cnf_file)
summarise(spc)

## Import all CNF files in a given directory
spc_dir <- system.file("extdata/BDX_LaBr_1/calibration", package = "gamma")
spc <- read(spc_dir)
summarise(spc)

## Import CNF files
## Spectra
spc_dir <- system.file("extdata/BDX_LaBr_1/calibration", package = "gamma")
spc <- read(spc_dir)

## Background
bkg_dir <- system.file("extdata/BDX_LaBr_1/background", package = "gamma")
bkg <- read(bkg_dir)

## Integrate background noise spectrum (normalized signal)
(int_bkg <- signal_integrate(bkg, range = c(300, 2800), energy = FALSE))

## Integrate spectra and substract background noise value (net signal)
(int_spc <- signal_integrate(spc, bkg, range = c(300, 2800), energy = FALSE))

## Import a CNF file
spc_file <- system.file("extdata/LaBr.TKA", package = "gamma")
(spc <- read(spc_file))

## Set peak positions (channel) and expected energy values
calib_lines <- list(
  channel = c(86, 495, 879),
  energy = c(238, 1461, 2615)
)

## Adjust the energy scale
(spc1 <- energy_calibrate(spc, lines = calib_lines))

## Inspect results
plot(spc1, xaxis = "energy", yaxis = "count") +
  ggplot2::geom_vline(xintercept = c(238, 1461, 2615), linetype = 3)

## Import a LaBr spectrum
LaBr_file <- system.file("extdata/LaBr.TKA", package = "gamma")
LaBr_spc <- read(LaBr_file)

## Find peaks by channel
(LaBr_pks <- peaks_find(LaBr_spc)) # Ugly
plot(LaBr_spc, LaBr_pks)

## Search peaks by channel
(LaBr_pks <- peaks_search(LaBr_spc, index = c(86L, 207L, 496L), span = 7))
plot(LaBr_spc, LaBr_pks, split = TRUE)

## Import a BEGe spectrum
BEGe_file <- system.file("extdata/BEGe.CNF", package = "gamma")
BEGe_spc <- read(BEGe_file)

## Search peaks by energy
(BEGe_pks <- peaks_search(BEGe_spc, index = c(47, 63, 911, 1460)))
plot(BEGe_spc, BEGe_pks, split = TRUE)

## Import CNF files
spc_file <- system.file("extdata/LaBr.CNF", package = "gamma")
spc <- read(spc_file)

## Plot spectrum
plot(spc)

## Slice
sliced <- signal_slice(spc)
plot(sliced)

sliced <- signal_slice(spc, -c(1:35))
plot(sliced)

sliced <- signal_slice(sliced, 450:550)
plot(sliced)

## Split
g <- rep(c("A", "B", "C"), c(250, 500, 274))
splited <- signal_split(spc, g)
plot(splited, facet = TRUE)

## Import CNF files
## Spectra
spc_dir <- system.file("extdata/BDX_LaBr_1/calibration", package = "gamma")
spc <- read(spc_dir)

## Background
bkg_dir <- system.file("extdata/BDX_LaBr_1/background", package = "gamma")
bkg <- read(bkg_dir)

## Get dose rate values
data("clermont")
(doses <- clermont[, c("gamma_dose", "gamma_error")])

## Build the calibration curve
calib_curve <- dose_fit(spc, bkg, doses,
                        range_Ni = c(300, 2800),
                        range_NiEi = c(165, 2800))

## Plot the curve
plot(calib_curve, threshold = "Ni")

## Estimate gamma dose rates
dose_predict(calib_curve, spc)

## Import all CNF files in a given directory
spc_dir <- system.file("extdata/BDX_LaBr_1/calibration", package = "gamma")
(spc <- read(spc_dir))

## Access
get_hash(spc)
get_names(spc)
get_livetime(spc)
get_realtime(spc)

lengths(spc)
range_energy(spc)

## Subset
spc[] # All spectra
spc[NULL] # All spectra
spc[1] # The first spectrum
spc[-6] # Delete the sixth spectrum
spc[1:3] # The first three spectra
spc[c(1, 3)] # The first and third spectra
spc["BRIQUE"] # The spectrum named 'BRIQUE'
spc[c("BRIQUE", "C347")] # The spectra named 'BRIQUE' and 'C347'
spc[1:3, "energy"] # The slot 'energy' of the first three spectra
spc[[1]]
spc[["BRIQUE"]]

# Import CNF files
spc_dir <- system.file("extdata/BDX_LaBr_1/calibration", package = "gamma")
spc <- read(spc_dir)

# Plot all spectra
plot(spc, yaxis = "rate", facet = FALSE) +
  ggplot2::theme_bw()

# Plot the spectrum named 'BRIQUE'
plot(spc, xaxis = "energy", yaxis = "count", select = "BRIQUE") +
  ggplot2::theme_bw()

# Plot the first three spectra
plot(spc, xaxis = "channel", yaxis = "rate", select = 1:3, facet = TRUE) +
  ggplot2::theme_bw()

## Import a Canberra CNF file
spc_file <- system.file("extdata/LaBr.CNF", package = "gamma")
(spc <- read(spc_file))

## Access
get_hash(spc)
get_names(spc)
get_livetime(spc)
get_realtime(spc)

length(spc)
range_energy(spc)

## Subset
spc[["date"]]
spc[["instrument"]]
spc[["file_format"]]

## Import a CNF file
spc_file <- system.file("extdata/LaBr.CNF", package = "gamma")
spc <- read(spc_file)

## Remove the first 35 channels
spc <- signal_slice(spc, -c(1:35))

## Linear baseline
bsl_linear <- baseline_linear(spc, from = 250, to = 750)
plot(spc, bsl_linear)

## SNIP baseline
bsl_snip <- baseline_snip(spc, LLS = FALSE, decreasing = FALSE, n = 100)
plot(spc, bsl_snip)

## Rubberband baseline
bsl_rubber <- baseline_rubberband(spc)
plot(spc, bsl_rubber)

## Remove baseline
spc_clean1 <- signal_correct(spc)
spc_clean2 <- spc - bsl_snip
all(spc_clean1 == spc_clean2)

plot(spc_clean1)

## ----setup, include=FALSE-----------------------------------------------------
knitr::opts_chunk$set(
  collapse = TRUE,
  message = FALSE,
  comment = "#>",
  out.width = NULL
)

## ----packages-----------------------------------------------------------------
library(gamma)

## ----import-------------------------------------------------------------------
# Automatically skip the first channels
# Import a CNF file
cnf_test <- system.file("extdata/LaBr.CNF", package = "gamma")
(spc_cnf <- read(cnf_test))

# Import a TKA file
tka_test <- system.file("extdata/LaBr.TKA", package = "gamma")
(spc_tka <- read(tka_test))

# Import all files in a given directory
files_test <- system.file("extdata", package = "gamma")
(spc <- read(files_test))

## ----inspect, fig.width=7, fig.height=5, fig.align="center"-------------------
# Plot CNF spectrum
plot(spc_cnf) +
  ggplot2::theme_bw()

## ----slice--------------------------------------------------------------------
# Use a square root transformation
sliced <- signal_slice(spc_tka)

## ----stabilize----------------------------------------------------------------
# Use a square root transformation
transformed <- signal_stabilize(sliced, f = sqrt)

## ----smoothing----------------------------------------------------------------
# Use a 21 point Savitzky-Golay-Filter to smooth the spectrum
smoothed <- signal_smooth(transformed, method = "savitzky", m = 21)

## ----baseline-estimate, fig.width=7, fig.height=5, fig.align="center"---------
# Estimate the baseline of a single file
baseline <- signal_baseline(smoothed, method = "SNIP", decreasing = TRUE)

# Plot spectrum + baseline
plot(smoothed, baseline) +
  ggplot2::labs(title = "Spectrum + baseline") +
  ggplot2::theme_bw()

## ----baseline-remove, fig.width=7, fig.height=5, fig.align="center"-----------
# Substract the estimated baseline
corrected <- smoothed - baseline
# Or, remove the baseline in one go
# corrected <- removeBaseline(smoothed)

# Plot the corrected spectrum
plot(corrected) +
  ggplot2::labs(title = "Baseline-corrected spectrum") +
  ggplot2::theme_bw()

## ----baseline-remove-multi, eval=FALSE----------------------------------------
#  # You can remove the baseline of multiple spectra in one go
#  # Note that the same parameters will be used for all spectra
#  clean <- signal_correct(spc)

## ----peak-detection-----------------------------------------------------------
# Detect peaks in a single file
peaks <- peaks_find(corrected)

# Plot spectrum + peaks
plot(corrected, peaks) +
  ggplot2::labs(title = "Peaks") +
  ggplot2::theme_bw()

## ----calibrate-fit, fig.width=7, fig.height=5, fig.align="center"-------------
# Set the energy values (in keV)
set_energy(peaks) <- c(238, NA, NA, NA, 1461, NA, NA, 2615)
peaks

# Calibrate the spectrum using the peak positions
scaled <- energy_calibrate(spc_tka, peaks)

# Plot the spectrum
plot(scaled, xaxis = "energy") +
  ggplot2::labs(title = "Calibrated spectrum") +
  ggplot2::theme_bw()

## ----calibrate-fixed----------------------------------------------------------
# Create a list of channel-enegy pairs
calib_lines <- list(
  channel = c(84, 492, 865),
  energy = c(238, 1461, 2615)
)

# Calibrate the spectrum using these fixed lines
scaled2 <- energy_calibrate(spc_tka, lines = calib_lines)

## ----pipe, fig.width=7, fig.height=5, fig.align="center", fig.show="hold"-----
# Spectrum pre-processing and peak detection
pks <- spc_tka |>
  signal_slice() |>
  signal_stabilize(f = sqrt) |>
  signal_smooth(method = "savitzky", m = 21) |>
  signal_correct(method = "SNIP", decreasing = TRUE, n = 100) |>
  peaks_find()

# Set the energy values (in keV)
set_energy(pks) <- c(238, NA, NA, NA, 1461, NA, NA, 2615)

# Calibrate the energy scale
cal <- energy_calibrate(spc_tka, pks)

# Plot spectrum
plot(cal, pks) +
  ggplot2::theme_bw()

## ----dose-rate-curves, eval=FALSE---------------------------------------------
#  # Load one of the built-in curves
#  data(BDX_LaBr_1) # IRAMAT-CRP2A (Bordeaux)
#  data(AIX_NaI_1) # CEREGE (Aix-en-Provence)

---
title: "Manual"
author: "N. Frerebeau"
date: "`r Sys.Date()`"
output:
  rmarkdown::html_vignette:
    fig_caption: yes
    toc: true
    number_sections: true
header-includes:
   - \usepackage{amsmath}
   - \usepackage{amssymb}
bibliography: bibliography.bib
vignette: >
  %\VignetteIndexEntry{Manual}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  message = FALSE,
  comment = "#>",
  out.width = NULL
)
```

```{r packages}
library(gamma)
```

# Overview

**gamma** is intended to process in-situ gamma-ray spectrometry measurements for luminescence dating. This package allows to import, inspect and (automatically) correct the energy scale of the spectrum. It provides methods for estimating the gamma dose rate by the use of a calibration curve. This package only supports Canberra CNF and TKA files.

Typical workflow:

1. Import spectrum data with `read()`,
2. Inspect spectrum with `plot()`,
3. Calibrate the energy scale with `energy_calibrate()`,
4. Estimate the gamma dose rate with `dose_predict()`.

The estimation of the gamma dose rate requires a calibration curve. This package contains several built-in curves, but as these are instrument-specific you may need to build your own (see `help(dose_fit)`). These built-in curves are in use in several labs and can be used to reproduce published results. Check out the dedicated vignette for an overview of the fitting process: `vignette("doserate")`

Note that **gamma** uses the *International System of Units*: energy values are assumed to be in keV and dose rates in µGy/y.

# Import file
Both Canberra CNF and TKA files can be imported.

```{r import}
# Automatically skip the first channels
# Import a CNF file
cnf_test <- system.file("extdata/LaBr.CNF", package = "gamma")
(spc_cnf <- read(cnf_test))

# Import a TKA file
tka_test <- system.file("extdata/LaBr.TKA", package = "gamma")
(spc_tka <- read(tka_test))

# Import all files in a given directory
files_test <- system.file("extdata", package = "gamma")
(spc <- read(files_test))
```

# Inspect spectrum
```{r inspect, fig.width=7, fig.height=5, fig.align="center"}
# Plot CNF spectrum
plot(spc_cnf) +
  ggplot2::theme_bw()
```

# Calibrate the energy scale
The energy calibration of a spectrum is the most tricky part. To do this, you must specify the position of at least three observed peaks and the corresponding energy value (in keV).

The package allows you to provide the channel-energy pairs you want to use. However, the spectrum can be noisy so it is difficult to properly determine the peak channel. In this case, a better approach may be to pre-process the spectrum (variance-stabilization, smoothing and baseline correction) and perform a peak detection. Once the identified peaks are satisfactory, you can set the corresponding energy values (in keV) and use these lines to calibrate the energy scale of the spectrum.

Regardless of the approach you choose, it is strongly recommended to check the result before proceeding.

## Workflow
The following steps illustrate how to properly fine-tune the parameters for spectrum processing before peak detection.

### Clean
Several channels can be dropped to retain only part of the spectrum. If no specific value is provided, an attempt is made to define the number of channels to skip at the beginning of the spectrum. This drops all channels before the highest count maximum. This is intended to deal with the artefact produced by the rapid growth of random background noise towards low energies.

```{r slice}
# Use a square root transformation
sliced <- signal_slice(spc_tka)
```

### Stabilization

The stabilization step aims at improving the identification of peaks with a low signal-to-noise ratio. This particularly targets higher energy peaks.

```{r stabilize}
# Use a square root transformation
transformed <- signal_stabilize(sliced, f = sqrt)
```

### Smoothing

```{r smoothing}
# Use a 21 point Savitzky-Golay-Filter to smooth the spectrum
smoothed <- signal_smooth(transformed, method = "savitzky", m = 21)
```

### Baseline correction

The baseline estimation is performed using the SNIP algorithm [@ryan1988; @morhac1997; @morhac2008]. You can apply the LLS operator to your data, use a decreasing clipping window or change the number of iterations (see references).

```{r baseline-estimate, fig.width=7, fig.height=5, fig.align="center"}
# Estimate the baseline of a single file
baseline <- signal_baseline(smoothed, method = "SNIP", decreasing = TRUE)

# Plot spectrum + baseline
plot(smoothed, baseline) +
  ggplot2::labs(title = "Spectrum + baseline") +
  ggplot2::theme_bw()
```

```{r baseline-remove, fig.width=7, fig.height=5, fig.align="center"}
# Substract the estimated baseline
corrected <- smoothed - baseline
# Or, remove the baseline in one go
# corrected <- removeBaseline(smoothed)

# Plot the corrected spectrum
plot(corrected) +
  ggplot2::labs(title = "Baseline-corrected spectrum") +
  ggplot2::theme_bw()
```

```{r baseline-remove-multi, eval=FALSE}
# You can remove the baseline of multiple spectra in one go
# Note that the same parameters will be used for all spectra
clean <- signal_correct(spc)
```

### Peak detection

Once you have a baseline-corrected spectrum, you can try to automatically find peaks in the spectrum. A local maximum has to be the highest one in the given window and has to be higher than $k$ times the noise to be recognized as peak.

```{r peak-detection}
# Detect peaks in a single file
peaks <- peaks_find(corrected)

# Plot spectrum + peaks
plot(corrected, peaks) +
  ggplot2::labs(title = "Peaks") +
  ggplot2::theme_bw()
```

### Energy scale calibration

If you know the correspondence between several channels and the energy scale, you can use these pairs of values to calibrate the spectrum. A second order polynomial model is fitted on these energy *vs* channel values, then used to predict the new energy scale of the spectrum.

You can use the results of the peak detection and set the expected energy values.
```{r calibrate-fit, fig.width=7, fig.height=5, fig.align="center"}
# Set the energy values (in keV)
set_energy(peaks) <- c(238, NA, NA, NA, 1461, NA, NA, 2615)
peaks

# Calibrate the spectrum using the peak positions
scaled <- energy_calibrate(spc_tka, peaks)

# Plot the spectrum
plot(scaled, xaxis = "energy") +
  ggplot2::labs(title = "Calibrated spectrum") +
  ggplot2::theme_bw()
```

Alternatively, you can do it by hand:

```{r calibrate-fixed}
# Create a list of channel-enegy pairs
calib_lines <- list(
  channel = c(84, 492, 865),
  energy = c(238, 1461, 2615)
)

# Calibrate the spectrum using these fixed lines
scaled2 <- energy_calibrate(spc_tka, lines = calib_lines)
```

## Use the pipe!

```{r pipe, fig.width=7, fig.height=5, fig.align="center", fig.show="hold"}
# Spectrum pre-processing and peak detection
pks <- spc_tka |>
  signal_slice() |>
  signal_stabilize(f = sqrt) |>
  signal_smooth(method = "savitzky", m = 21) |>
  signal_correct(method = "SNIP", decreasing = TRUE, n = 100) |>
  peaks_find()

# Set the energy values (in keV)
set_energy(pks) <- c(238, NA, NA, NA, 1461, NA, NA, 2615)

# Calibrate the energy scale
cal <- energy_calibrate(spc_tka, pks)

# Plot spectrum
plot(cal, pks) +
  ggplot2::theme_bw()
```

# Estimate the gamma dose rate

To estimate the gamma dose rate, you can either use one of the calibration curves distributed with this package or build your own.

```{r dose-rate-curves, eval=FALSE}
# Load one of the built-in curves
data(BDX_LaBr_1) # IRAMAT-CRP2A (Bordeaux)
data(AIX_NaI_1) # CEREGE (Aix-en-Provence)
```

The construction of a calibration curve requires a set of reference spectra for which the gamma dose rate is known and a background noise measurement. First, each reference spectrum is integrated over a given interval, then normalized to active time and corrected for background noise. The dose rate is finally modelled by the integrated signal value used as a linear predictor.

See `vignette(doserate)` for a reproducible example.

# References

---
title: "Obtaining a Dose Rate Calibration Curve"
author: "N. Frerebeau, B. Lebrun, S. Kreutzer"
date: "Last modified: `r Sys.Date()`"
output:
  rmarkdown::html_vignette:
    fig_caption: yes
    toc: true
    number_sections: true
header-includes:
   - \usepackage{amsmath}
   - \usepackage{amssymb}
bibliography: bibliography.bib
vignette: >
  %\VignetteIndexEntry{Obtaining a Dose Rate Calibration Curve}
  %\VignetteEncoding{UTF-8}
  %\VignetteEngine{knitr::rmarkdown}
---

```{r setup, include=FALSE}
knitr::opts_chunk$set(
  collapse = TRUE,
  message = FALSE,
  fig.width = 7,
  fig.height = 3.5,
  comment = "#>"
)
```

# Scope

This vignette walks you through the steps to obtain a calibration curve for the
gamma dose rate prediction. You will need the calibration curve to calculate 
the gamma dose rate from spectra measured in the field where the true gamma dose
is yet to be determined. In other words, you will need this curve to analyse
your field data. 

# Load library and import files

First things first, let's load the **gamma** package.

```{r packages}
library(gamma)
```

Now, we will use already measured spectra shipped with **gamma** for this example.
If you determine your calibration curve, you will need to use
your own data. All data used here were measured with a NaI probe. 

```{r import}
# Import CNF files for calibration
spc_dir <- system.file("extdata/AIX_NaI_1/calibration", package = "gamma")
spc <- read(spc_dir)
spc

# Import a CNF file of background measurement
bkg_dir <- system.file("extdata/AIX_NaI_1/background", package = "gamma")
bkg <- read(bkg_dir)
bkg
```

The object `spc` is a set of spectra measured in settings around Clermont-Ferrand 
[@miallier2009] and Bordeaux [@richter2010] with a known gamma dose rate, 
where `bgk` is a background curve measured in a lead castle. 

# Energy scale calibration

Before we can further work with the spectra, we have to perform an energy calibration, 
this is assigning values in terms of energy to the channel numbers. 

## Reference Spectra

First, we remove the baseline from the set of spectra for easier peak detection. 
, in the following subsections, we perform and apply the energy calibration 
to each spectrum, including the background spectrum. One subsection for each
spectrum with the corresponding R code.

```{r signal}
# Spectrum pre-processing
# Remove baseline for peak detection
bsl <- spc |>
  signal_slice(-1:-40) |>
  signal_stabilize(f = sqrt) |>
  signal_smooth(method = "savitzky", m = 21) |>
  signal_correct()
```

### BRIQUE
```{r calibrate-BRIQUE}
# Peak detection
pks <- peaks_find(bsl[["BRIQUE"]])
# Set energy values
set_energy(pks) <- c(238, NA, NA, NA, 1461, NA, NA, 2615)
# Adjust the energy scale
BRIQUE <- energy_calibrate(spc[["BRIQUE"]], pks)
```

```{r plot-BRIQUE, echo=FALSE}
plot(BRIQUE, pks) +
  ggplot2::theme_bw()
```

### C341
```{r calibrate-C341}
# Spectrum pre-processing and peak detection
pks <- peaks_find(bsl[["C341"]])
# Set energy values
set_energy(pks) <- c(238, NA, NA, NA, 1461, NA, 2615)
# Adjust the energy scale
C341 <- energy_calibrate(spc[["C341"]], pks)
```

```{r plot-C341, echo=FALSE}
plot(C341, pks) +
  ggplot2::theme_bw()
```

### C347
```{r calibrate-C347}
# Spectrum pre-processing and peak detection
pks <- peaks_find(bsl[["C347"]], span = 10)
# Set energy values
set_energy(pks) <- c(238, NA, NA, NA, NA, 1461, NA, 2615)
# Adjust the energy scale
C347 <- energy_calibrate(spc[["C347"]], pks)
```

```{r plot-C347, echo=FALSE}
plot(C347, pks) +
  ggplot2::theme_bw()
```

### GOU
```{r calibrate-GOU}
# Spectrum pre-processing and peak detection
pks <- peaks_find(bsl[["GOU"]])
# Set energy values
set_energy(pks) <- c(238, NA, NA, NA, 1461, NA, NA, 2615)
# Adjust the energy scale
GOU <- energy_calibrate(spc[["GOU"]], pks)
```

```{r plot-GOU, echo=FALSE}
plot(GOU, pks) +
  ggplot2::theme_bw()
```

### PEP
```{r calibrate-PEP}
# Spectrum pre-processing and peak detection
pks <- peaks_find(bsl[["PEP"]])
# Set energy values
set_energy(pks) <- c(238, NA, NA, NA, 1461, NA, NA, 2615)
# Adjust the energy scale
PEP <- energy_calibrate(spc[["PEP"]], pks)
```

```{r plot-PEP, echo=FALSE}
plot(PEP, pks) +
  ggplot2::theme_bw()
```

### Background Spectrum
```{r calibrate-bkg}
# Pb212, K40, Tl208
lines <- data.frame(
  channel = c(86, 496, 870),
  energy = c(238, 1461, 2615)
) 
bkg_scaled <- energy_calibrate(bkg, lines = lines)
```

```{r plot-bkg, echo=FALSE}
plot(bkg_scaled, xaxis = "energy", yaxis = "rate") +
  ggplot2::geom_vline(xintercept = c(238, 1461, 2615), linetype = 3) +
  ggplot2::theme_bw()
```

## Signal integration

Two methods can be used to calculate a gamma dose rate from the measured counts: the 'window' 
method and the 'threshold' method. The 'window' method compares counts under nuclide-specific gamma-ray peaks to  
reference spectra where the nuclide concentration is known. In this case, only 
a small part of the spectrum is used. The 'threshold' method uses the circumstance
that above a certain threshold, the number of counts for a given dose rate changes
only slightly with the emitters [e.g., U, Th, K -- cf. @guerin2011; @mercier2007; @lvborg1974]. 

The exact position of this threshold depends on the used probe and needs to be determined 
either by modelling or measurements of different sites with known but different radionuclides
concentrations. 

For this example (and in the package **gamma** in general), we will focus solely on the 'threshold' method, a crucial tool 
used to derive a calibration curve and derive gamma dose rates. This method's practical application in deriving a calibration curve 
is a key aspect of our exploration.  Our first step is to combine the energy-calibrated spectra into a unified set, 
laying the foundation for the subsequent calculations. 

```{r calibrate-spc}
spc_scaled <- list(BRIQUE, C341, C347, GOU, PEP)
spc_scaled <- methods::as(spc_scaled, "GammaSpectra")
spc_scaled
```

Now we can integrate the spectra using either the cumulative count spectra or
the energy corresponding to a certain energy [cf. @guerin2011 for details]. 

The following two subsections show how to derive the integrated spectrometer
response with each technique. In both cases, however, we assume that the
**threshold itself is already known**! The examples are for educational reasons
only and the here used function `signal_integrate()` is used in the back by the
function `dose_fit()` we will use later to derive the calibration curve. 

### Using the count threshold
```{r integrate-Ni}
# Integration range (in keV)
Ni_range <- c(200, 2800)

# Integrate background spectrum
Ni_bkg <- signal_integrate(
  object = bkg_scaled, 
  range = Ni_range, 
  energy = FALSE)

# Integrate reference spectra
Ni_spc <- signal_integrate(
  object = spc_scaled, 
  range = Ni_range, 
  background = Ni_bkg, 
  energy = FALSE, 
  simplify = TRUE)
```

### Using the energy threshold

```{r integrate-NiEi}
# Integration range (in keV)
NiEi_range <- c(200, 2800)

# Integrate background spectrum
NiEi_bkg <- signal_integrate(
  object = bkg_scaled, 
  range = NiEi_range, 
  energy = TRUE)

# Integrate reference spectra
NiEi_signal <- signal_integrate(
  object = spc_scaled, 
  range = NiEi_range, 
  background = NiEi_bkg, 
  energy = TRUE,
  simplify = TRUE)
```

## Get dose rate calibration curve

The dose rate calibration curve models detector specific counts against a know gamma-dose so
that such gamma dose can be derived from unknown spectra with the the same detector.

### Model calibration curve

To model the calibration curve we will need have measured sites with known radionuclide concentrations.
`'gamma'` ships a table with values from know sites in the dataset `clermont`. If you, as we have, measured
with your probe in that locations you do not have to manually add values from @miallier2009 or @richter2010.

```{r}
# Get reference dose rates
data("clermont")
doses <- clermont[, c("gamma_dose", "gamma_error")]
```

```{r, echo = FALSE}
knitr::kable(clermont)
```

In the next step we create a list with additional information about the used equipment
to be passed onto the calibration R object. You have to modify those values for your own 
detector.

```{r}
# Metadata
info <- list(
  laboratory = "CEREGE",
  instrument = "InSpector 1000",
  detector = "NaI",
  authors = "CEREGE Luminescence Team"
)
```

In the last step we construct the calibration curve and inspect the results. 

```{r}
# Build the calibration curve
AIX_NaI <- dose_fit(
  object = spc_scaled, 
  background = bkg_scaled, 
  doses = doses,
  range_Ni = Ni_range, 
  range_NiEi = NiEi_range,
  details = info
)
AIX_NaI 
```

If this information seems too opaque , we can further inspect the output numerically 
(`summary()`) and graphically using the package `plot()` methods.

```{r}
# show summary
summarise(AIX_NaI)
```

```{r calibration, fig.width=3.5, fig.show='hold'}
# plot calibration curves
plot(AIX_NaI, energy = FALSE) +
  ggplot2::theme_bw()
plot(AIX_NaI, energy = TRUE) +
  ggplot2::theme_bw()
```

Well, this looks all good and should make a good calibration curve. 
To use this calibration curve in the future, you can save the object using the 
base R function `save()`. 

```{r, eval=FALSE}
save(AIX_NaI, file = "<you_path>/<date>_NaI_DoseRate_Calibration.rda")
```

```{r save, eval=FALSE, echo=FALSE}
# DANGER ZONE
# AIX_NaI_1 <- AIX_NaI
# usethis::use_data(AIX_NaI_1, internal = FALSE, overwrite = FALSE)
```

### Check the model

Although the calibration curve appears reasonable, we can use a few additional 
R plots to further inspect the performed calibration. 

#### Count threshold (`Ni`)

```{r check-Ni, echo=FALSE, fig.width=3.5, fig.show='hold'}
Ni_residuals  <- get_residuals(AIX_NaI[["Ni"]])

# Residuals vs fitted values
ggplot2::ggplot(Ni_residuals, ggplot2::aes(x = fitted, y = residuals)) +
  ggplot2::geom_hline(yintercept = 0, linetype = 3) +
  ggplot2::geom_segment(ggplot2::aes(x = fitted, xend = fitted,
                                     y = 0, yend = residuals)) + 
  ggplot2::geom_point() +
  ggplot2::theme_bw() +
  ggplot2::labs(title = "Residuals vs fitted values",
                x = "Fitted values", y = "Residuals")

# Std. residuals vs fitted values
ggplot2::ggplot(Ni_residuals, ggplot2::aes(x = fitted, y = standardized)) +
  ggplot2::geom_hline(yintercept = 0, linetype = 3) +
  ggplot2::geom_hline(yintercept = c(-2, 2), linetype = 2) +
  ggplot2::geom_segment(ggplot2::aes(x = fitted, xend = fitted,
                                     y = 0, yend = standardized)) + 
  ggplot2::geom_point() +
  ggplot2::theme_bw() +
  ggplot2::labs(title = "Std. residuals vs fitted values",
                x = "Fitted values", y = "Standardized residuals")

# Normal QQ plot of standardized residuals
ggplot2::ggplot(Ni_residuals, ggplot2::aes(sample = standardized)) +
  ggplot2::geom_abline(slope = 1, intercept = 0) +
  ggplot2::geom_qq_line(colour = "red") +
  ggplot2::geom_qq() +
  ggplot2::theme_bw() +
  ggplot2::labs(title = "Normal QQ plot",
                x = "Theoretical quantiles",
                y = "Standardize residuals")

# Cook's distance
# ggplot2::ggplot(Ni_residuals, ggplot2::aes(x = name, y = cook)) +
#   ggplot2::geom_hline(yintercept = 0, linetype = 3) +
#   ggplot2::geom_hline(yintercept = 1, linetype = 2) +
#   ggplot2::geom_segment(ggplot2::aes(x = name, xend = name,
#                                      y = 0, yend = cook)) +
#   ggplot2::geom_point() +
#   ggplot2::theme_bw() +
#   ggplot2::labs(title = "Cook's distance",
#                 x = "Observation", y = "D")
```

#### Energy threshold (`Ni.Ei`)

```{r check-NiEi, echo=FALSE, fig.width=3.5, fig.show='hold'}
NiEi_residuals  <- get_residuals(AIX_NaI[["NiEi"]])

# Residuals vs fitted values
ggplot2::ggplot(NiEi_residuals, ggplot2::aes(x = fitted, y = residuals)) +
  ggplot2::geom_hline(yintercept = 0, linetype = 3) +
  ggplot2::geom_segment(ggplot2::aes(x = fitted, xend = fitted,
                                     y = 0, yend = residuals)) + 
  ggplot2::geom_point() +
  ggplot2::theme_bw() +
  ggplot2::labs(title = "Residuals vs fitted values",
                x = "Fitted values", y = "Residuals")

# Std. residuals vs fitted values
ggplot2::ggplot(NiEi_residuals, ggplot2::aes(x = fitted, y = standardized)) +
  ggplot2::geom_hline(yintercept = 0, linetype = 3) +
  ggplot2::geom_hline(yintercept = c(-2, 2), linetype = 2) +
  ggplot2::geom_segment(ggplot2::aes(x = fitted, xend = fitted,
                                     y = 0, yend = standardized)) + 
  ggplot2::geom_point() +
  ggplot2::theme_bw() +
  ggplot2::labs(title = "Std. residuals vs fitted values",
                x = "Fitted values", y = "Standardized residuals")

# Normal QQ plot of standardized residuals
ggplot2::ggplot(NiEi_residuals, ggplot2::aes(sample = standardized)) +
  ggplot2::geom_abline(slope = 1, intercept = 0) +
  ggplot2::geom_qq_line(colour = "red") +
  ggplot2::geom_qq() +
  ggplot2::theme_bw() +
  ggplot2::labs(title = "Normal QQ plot",
                x = "Theoretical quantiles",
                y = "Standardize residuals")

# Cook's distance
# ggplot2::ggplot(NiEi_residuals, ggplot2::aes(x = name, y = cook)) +
#   ggplot2::geom_hline(yintercept = 0, linetype = 3) +
#   ggplot2::geom_hline(yintercept = 1, linetype = 2) +
#   ggplot2::geom_segment(ggplot2::aes(x = name, xend = name,
#                                      y = 0, yend = cook)) +
#   ggplot2::geom_point() +
#   ggplot2::theme_bw() +
#   ggplot2::labs(title = "Cook's distance",
#                 x = "Observation", y = "D")
```

## Application example: opredict new dose rates

After calibrating our detector, it is time to derive gamma dose rates from 
sites with unknown radionuclide concentrations. As mentioned above, we will use 
data we ship with `'gamma'`. Our routine analysis consists of 
only three steps: 

### Import measured data

```{r}
# Import CNF files for dose rate prediction
test_dir <- system.file("extdata/AIX_NaI_1/test", package = "gamma")
test <- read(test_dir)
```

### Inspect the spectra 

```{r predict}
# Inspect spectra
plot(test, yaxis = "rate") +
  ggplot2::theme_bw()
```

### Energy calibrate the spectra

```{r}
# Pb212, K40, Tl208
pks <- data.frame(
  channel = c(86, 490, 870),
  energy = c(238, 1461, 2615)
) |> as("PeakPosition")

## energy calibrate
test <- energy_calibrate(test, pks)

## check the calibration for one curve
plot(test[[1]], pks) +
  ggplot2::theme_bw()

## show all energy calibrated spectra 
# Inspect spectra
plot(test, xaxis = "energy", yaxis = "rate") +
  ggplot2::theme_bw()
```

### Predict the dose rates

```{r}
rates <- dose_predict(AIX_NaI, test, sigma = 1.96)
rates
```

*Note: We assume here that the energy scale of each spectrum was adjusted first.*

# Outro: our R session {-}

Finally, for transparency, the R session setting used for rendering this vignette. 
```{r session-info, echo=FALSE}
sessionInfo()
```

# References {-}
